package com.muyu.common.system.remote;

import com.muyu.common.core.constant.ServiceNameConstants;
import com.muyu.common.core.domain.Result;
import com.muyu.common.system.domain.SysDept;
import com.muyu.common.system.remote.factory.RemoteDeptFallbackFactory;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

/**
 * 部门服务 RemoteDeptService
 *
 * @author LeYang
 * on 2024/5/11
 */
@FeignClient(contextId = "RemoteDeptService",
        value = ServiceNameConstants.FILE_SERVICE,
        fallbackFactory = RemoteDeptFallbackFactory.class)

public interface RemoteDeptService {

    @PostMapping("/selectDept")
    public Result<List<SysDept>> deptList();
    @PostMapping("/selectDeptList")
    public Result<List<SysDept>> selectDeptList (@RequestBody Long deptId);
}
