package com.muyu.common.system.remote.factory;

import com.muyu.common.core.domain.Result;
import com.muyu.common.system.domain.SysDept;
import com.muyu.common.system.remote.RemoteDeptService;
import org.springframework.cloud.openfeign.FallbackFactory;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * 部门服务 RemoteDeptFallbackFactory
 *
 * @author LeYang
 * on 2024/5/11
 */
@Component
public class RemoteDeptFallbackFactory implements FallbackFactory<RemoteDeptService> {
    @Override
    public RemoteDeptService create(Throwable cause) {
        return new RemoteDeptService() {
            @Override
            public Result<List<SysDept>> deptList() {
                return  Result.error(cause.getMessage());
            }

            @Override
            public Result<List<SysDept>> selectDeptList(Long deptId) {
                return Result.error(cause.getMessage());
            }
        };
    }
}
