package com.muyu.source.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.muyu.common.system.domain.SysDept;
import com.muyu.source.datadisplay.DataDisplay;
import com.muyu.source.dept.DataSource;
import com.muyu.source.dept.DeptUserKvt;
import com.muyu.source.dictionary.Diction;
import com.muyu.source.dictionary.DictionaryType;
import com.muyu.source.dictionary.Dictionaryy;
import com.muyu.source.domain.*;
import com.muyu.source.permissions.PermissionsUser;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * kvt
Mapper接口
 *
 * @author muyu
 * @date 2024-04-20
 */
public interface KvtMapper extends BaseMapper<Kvt> {

    List<DataType> dataTypeList();


    Kvt findName(String name);

    List<AssetStructureList> assetStructureList();


    void synchronizationAdd(Kvt kvt);


    List<ChildrenList> selectDepartment(String databaseName);

    Kvt selectType(String databaseName);

    List<DataStructure> selectDataStructure(@Param("databaseName") String databaseName, @Param("name") String name);

    void add(@Param("dataStructure") List<DataStructure> dataStructure);


    List<DataStructure> selectDataStur(@Param("tableName") String tableName);

    void ChildAdd(@Param("assetStructureLists") List<ChildrenList> assetStructureLists);

    Child selectChild(String tableName);

    List<DataStructure> selectChildAll();

    void DataAuthorizationAdd(DataAuthorization build);

    List<SysDept> deptList();




    void del(String tableName);

    List<String> selectTable(String databaseName);

    List<DictionaryType> selectDictionaryy(Integer id);

    DictionaryType selectDictionaryType(String type);

    void childAdd(Child build1);

    void dictionaryTypeAdd(Dictionaryy diction);

    void dictionTypeAdd(DictionaryType dictionaryType);

    List<Diction> selectDictionary();

    List<Dictionaryy> selectDiction(String type);

    Dictionaryy selectDictionaryTypeId(Integer  id);

    void updateDictionaryTypeId(Dictionaryy dictionaryy);

    void DeptUserKvtAdd(DeptUserKvt build);

    List<DataSource> selectDataSource(String tableName);

    void utilAssetModel(DataStructure dataStructure);

    List<Synchronization> selectSyn();

    List<Child> list();

    void dataDisplayAdd(@Param("dataDisplays") List<DataDisplay> dataDisplays);

    List<DataDisplay> listResult();

    List<DataDisplay> selectDataDisplayName(@Param("name") String name);

    void permissionsUserAdd(PermissionsUser build);

    void permissionsUserDel(PermissionsUser permissionsUser);

    List<PermissionsUser> selectPermission();

    PermissionsUser permissionsUserSelect(PermissionsUser build);

    List<Object> selectTableName(String tableName);

    List<DataStructure> selectDataStructureAll();



    List<DataAuthorization> selectDataDisplayList(String databaseName);

    List<DataStructure> selectDataStructureTableName(String tableName);

    List<DataDisplay> selectDataDisplayVal(String tableName);
}
