package com.muyu.source.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.muyu.common.core.domain.Result;
import com.muyu.common.system.domain.SysDept;
import com.muyu.source.dataStructure.OverallDataStructure;
import com.muyu.source.datadisplay.DataDisplay;
import com.muyu.source.dictionary.Diction;
import com.muyu.source.dictionary.DictionaryType;
import com.muyu.source.dictionary.Dictionaryy;
import com.muyu.source.domain.*;
import com.muyu.source.permissions.PermissionsUser;
import org.apache.ibatis.annotations.Param;

import java.sql.SQLException;
import java.util.List;

/**
 * kvt
Service接口
 *
 * @author muyu
 * @date 2024-04-20
 */
public interface KvtService extends IService<Kvt> {

    public List<Kvt> list(Kvt kvt);

    boolean connectionTest(Kvt kvt) throws ClassNotFoundException, SQLException;

    List<DataType> dataTypeList();


    List<AssetStructureList> assetStructureList();

    List<ChildrenList> selectDepartment(String  databaseName);

    List<DataStructure> selectDataStructure(@Param("databaseName") String databaseName, @Param("name") String name);



    List<DataStructure> selectDataStur(String tableName);

    Child selectChild(String tableName);

    List<DataStructure> selectChildAll();

    List<SysDept> deptList();

    List<Diction> selectDictionaryy(Integer id);


    Result synchronizationAdd(Kvt kvt) throws SQLException, ClassNotFoundException;

    void dictionaryTypeAdd(Dictionaryy diction);

    void dictionTypeAdd(DictionaryType dictionaryType);

    Dictionaryy selectDictionaryTypeId(Integer  id);

    void delDictionaryTypeId(Dictionaryy dictionaryy);

    void utilAssetModel(DataStructure dataStructure);

    Result<OverallDataStructure> OverallDataStructure();


    List<DataDisplay> listResult();

    List<DataDisplay> selectDataDisplayName(String name);

    Result permissionsUserAdd(PermissionsUser permissionsUser);

    void permissionsUserDel(PermissionsUser permissionsUser);

    List<PermissionsUser> selectPermission();


    List<String> selectTable(String databaseName);

    List<Object> selectTableName(String tableName);

    void AddDepartment(PermissionsUser permissionsUser);

    List<DataAuthorization> selectDataDisplayList(String databaseName);

    List<DataStructure> selectDataStructureTableName(String tableName);

    List<DataDisplay> selectDataDisplayVal(String tableName);
}
