package com.muyu.engine.client;

import com.muyu.common.core.domain.Result;
import com.muyu.engine.domain.RuleEngine;
import com.muyu.engine.domain.rule_engine_version.RuleEngineVersion;
import com.muyu.engine.remote.RuleEngineManangerService;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.ApplicationArguments;
import org.springframework.boot.ApplicationRunner;

import javax.tools.*;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.net.URI;
import java.util.Arrays;
import java.util.List;

/**
 * 初始化加载 EngClientRunner
 *
 * @author LeYang
 * on 2024/5/9
 */
@Log4j2
public class EngClientRunner implements ApplicationRunner {

   @Autowired
   private RuleEngineManangerService ruleEngineManangerService;;

    @Override
    public void run(ApplicationArguments args) throws Exception {
        Result<List<RuleEngine>> listResult = ruleEngineManangerService.selectRuleEngine();

//        Result<List<RuleEngineVersion>> result = ruleEngineManangerService.RuleEngineVersionList(new RuleEngineVersionQueryReq());
//        List<RuleEngineVersion> data = result.getData();
//        System.out.println("result = " + result);
//        data.forEach(ruleEngineVersion -> {
//            //如何判断指定目录下是否有.java文件
//            this.writeCodeAdd(ruleEngineVersion);
//        });


    }
    private String url ="D:\\work\\zglkh\\cloud-server\\muyu-modules\\muyu-rule-engine\\muyu-rule-engine-common\\src\\main\\java\\com\\muyu\\engine\\java\\";

    public void writeCodeAdd(RuleEngineVersion ruleEngineVersion) {
        try {
            String originalVersionCode = ruleEngineVersion.getVersionCode();
            // 提取第一个字符并转换为大写
            String firstCharUpperCase = originalVersionCode.substring(0, 1).toUpperCase();
            // 截取从第二个字符到末尾的子串
            String restOfVersionCode = originalVersionCode.substring(1);
            // 将首字母大写和剩余部分拼接起来
            String newVersionCode = firstCharUpperCase + restOfVersionCode;

            String className = newVersionCode;

            //编译
            String path=url+className+".java";

            BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(path));
            // 写入内容
            bufferedWriter.write(ruleEngineVersion.getCodeIng());
            // 关闭流
            bufferedWriter.close();
            //编译内容
            String content = ruleEngineVersion.getCodeIng();
            // 指定输出目录
            JavaCompiler compiler = ToolProvider.getSystemJavaCompiler();
            // 获取编译器
            try (StandardJavaFileManager fileManager = compiler.getStandardFileManager(null, null, null)) {
                // 创建一个内存中的源文件
                JavaFileObject sourceFileObject = new JavaSourceFromString(className, content);

                // 编译选项
                Iterable<String> options = Arrays.asList("-d", url);
                // 编译源代码
                JavaCompiler.CompilationTask task = compiler.getTask(null, fileManager, null, options, null, Arrays.asList(sourceFileObject));
                boolean success = task.call();

                if (success) {
                    System.out.println("编译成功");
                } else {
                    System.out.println("编译失败");
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }catch (Exception e) {
            e.printStackTrace();
        }

    }
    //内存中的源文件
    static class JavaSourceFromString extends SimpleJavaFileObject {
        final String code;
        // 构造方法
        JavaSourceFromString(String name, String code) {
            // URI
            super(URI.create("string:///" + name.replace('.', '/') + Kind.SOURCE.extension), Kind.SOURCE);
            this.code = code;
        }
        // 返回源代码
        @Override
        public CharSequence getCharContent(boolean ignoreEncodingErrors) {
            return code;
        }
    }
}
