package com.muyu.scope;

import com.muyu.scope.model.DataProcessModel;
import lombok.Data;
import lombok.experimental.SuperBuilder;

/**
 * 数据模型上下文
 * @Author: DongZeLiang
 * @date: 2024/4/29
 * @Description:
 * @Version: 1.0
 */
@Data
@SuperBuilder
public class DataModelContext {

    private static final ThreadLocal<DataProcessModel> THREAD_LOCAL = new ThreadLocal<>();

    private final DataSetContext dataSetContext;

    public DataModelContext (DataSetContext dataSetContext) {
        this.dataSetContext = dataSetContext;
    }


    public static DataProcessModel get() {
        return THREAD_LOCAL.get();
    }

    public static void set(DataProcessModel dataProcessModel){
         THREAD_LOCAL.set(dataProcessModel);
    }

    public static void remove() {
        THREAD_LOCAL.remove();
    }

}
