package com.muyu.scope;

import com.muyu.scope.model.DataSetProcessModel;

/**
 * 数据集上下文
 * @Author: DongZeLiang
 * @date: 2024/4/29
 * @Description:
 * @Version: 1.0
 */
public class DataSetContext {

    private static final ThreadLocal<DataSetProcessModel> THREAD_LOCAL = new ThreadLocal<>();

    private final RecordContext recordContext;

    public DataSetContext (RecordContext recordContext) {
        this.recordContext = recordContext;
    }


      public static DataSetProcessModel get(){
            return THREAD_LOCAL.get();
      }

      public static void set(DataSetProcessModel dataSetProcessModel){
         THREAD_LOCAL.set(dataSetProcessModel);
      }

      public static void remove(){
          THREAD_LOCAL.remove();
      }

}
