package com.muyu.scope;

import com.muyu.scope.model.RecordProcessModel;

/**
 * 记录/资产模型上文
 * @Author: DongZeLiang
 * @date: 2024/4/29
 * @Description:
 * @Version: 1.0
 */
public class RecordContext  {

    private static final ThreadLocal<RecordProcessModel> THREAD_LOCAL = new ThreadLocal<>();

    private final TaskContext taskContext;


    private RecordContext (TaskContext taskContext) {
        this.taskContext = taskContext;
    }

   public static RecordProcessModel get(){
        return THREAD_LOCAL.get();
   }

   public static void  set(RecordProcessModel recordProcessModel){
        THREAD_LOCAL.set(recordProcessModel);
   }

   public static void remove(){
        THREAD_LOCAL.remove();
   }
}
